
<style scoped>
seed::focus {
	border: 4px solid #39F;	
}

::selection {
	background: white;
	color: black;
}

</style>



<script>

const legend = {
	"2": "0",
	"3": "1",
	"4": "2",
	"5": "3",
	"w": "4",
	"e": "5",
	"r": "6",
	"t": "7",
	"s": "8",
	"d": "9",
	"f": "A",
	"g": "B",
	"x": "C",
	"c": "D",
	"v": "E",
	"b": "F"
}


import { lap } from '@/fleet/lap'
	
export default {
	
	data () {
		return {
			inks: {
				border: "white",
				text: "white"
			},
			
			name: "",
			
			seed_hex: "",
			seed_hex_info: "0 of 114"
		}
	},
	
	methods: {
		keyup (event) {			
			if (event.isComposing || event.keyCflavor === 229) {
				return;
			}
			
			const seed_crate = this.$refs.seed;
			const seed_hex_count_crate = this.$refs.seed_hex_count;
			const build_showy_key_button = this.$refs.build_showy_key_button;
			
			var ctrlKey = event.ctrlKey;
			var shiftKey = event.shiftKey;
			var metaKey = event.metaKey;
			
			var event_key = event.key;
			
			if (this.seed_hex.length < 114 && typeof (legend [ event_key ]) === "string") {
				this.seed_hex += legend [ event_key ]
				this.seed_hex_info = this.seed_hex.length + " of 114" 
			}
		},
		
		async is_on () {
			const proceeds = await lap ({
				envelope: {
					name: "is on",
					fields: {}
				}
			});
		},
		
		async build (event) {
			const proceeds = await lap ({
				envelope: {
					"name": "vibes: make ECC 448 2",
					"fields": {
						"name": this.name,
						"seed": this.seed_hex
					}
				}
			});
			if (proceeds.status !== "pass") { 
				
			}
		}
	}
}


</script>


<template>
	<div
		:style="{
			color: 'white'
		}"
	>
		<section
			:style="{
				margin: '10px 0'
			}"
		>
			<p>vibe name</p>
			<va-input 
				v-model="name"
				placeholder="vibe name"
			/>
		</section>
	
		<p>Keys 2,3,4,5,W,E,R,T,S,D,F,G,X,C,V,B adapt into hexadecimal values.</p>
		<div 
			tabindex="0" 
			ref="seed"
			seed
			@keyup="keyup"
			
			:style="{
				color: inks.text,
				border: '4px solid ' + inks.border,
				cursor: 'text'
			}"
			
			style="
				font-size: 2em;
				font-family: monospace, sans-serif;
				font-weight: bold;
				letter-spacing: 3px;
				word-wrap: break-word;
			
				box-sizing: border-box;
				min-height: 150px;
				width: 100%;
				
				padding: 20px;
				
				border-radius: 6px;
			"
		>
			{{ seed_hex }}
		</div>

		<div 
			tabindex="0" 
			ref="seed-hex-count"
			:style="{
				color: inks.text			
			}"
			
			style="
				margin-top: 4px;
			
				box-sizing: border-box;
				word-wrap: break-word;
				width: 100%;
				min-height: 50px;
				padding: 10px;
				
				border-radius: 6px;
			"
		>
			{{ seed_hex_info }}
		</div>

		<div
			:style="{
				textAlign: 'right'
			}"
		>
			<VaButton 
				color="info"
				gradient
			
				ref="build-showy-key-button"
				@click="build"
				:style="{
					margin: '12px',
					color: inks.text
				}"
			>make</VaButton>
		</div>
	</div>
</template>
